/*
  Commands
    00  Echo Ping
    01  Display Time
    02  Display Temp
    10  Display Message Line 0
    11  Display Message Line 1
    12  Display Message Line 2
    13  Display Message Line 3
 */

#include <SPI.h>
#include <Time.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(6, 10, 5, 4, 3, 2);
byte data[18];
int count;

void setup(){
  Mirf.cePin = 8;
  Mirf.csnPin = 7;
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
  Mirf.setRADDR((byte *)"serv1");
  Mirf.payload = sizeof(data);
  Mirf.config();
  lcd.begin(16, 4);
  lcd.print("Mega Mirf Server");
}

void loop(){
  if(!Mirf.isSending() && Mirf.dataReady()){
    Mirf.getData(data);

    switch (data[0]) {
      case 0x01:  // Echo Ping
        Mirf.setTADDR((byte *)"clie1");
        Mirf.send(data);
        count++;
        lcd.setCursor(0,0);
        lcd.print("Mega Mirf Server");
        lcd.setCursor(0,2);
        lcd.print("Ping Reply: ");
        lcd.print(count);
        break;

      case 0x02:  // Display Time
        break;

      case 0x03:  // Display Temp
        break;

      case 0x10:  // Display Line 0 Message
        lcd.clear();
        lcd.setCursor(0,0);
        for(int i=0;i<data[1];i++) {
          lcd.print(data[i+2]);
        }
        break;

      case 0x11:  // Display Line 1 Message
        lcd.clear();
        lcd.setCursor(0,1);
        for(int i=0;i<data[1];i++) {
          lcd.print(data[i+2]);
        }
        break;

      case 0x12:  // Display Line 2 Message
        lcd.clear();
        lcd.setCursor(0,2);
        for(int i=0;i<data[1];i++) {
          lcd.print(data[i+2]);
        }
        break;

      case 0x13:  // Display Line 3 Message
        lcd.clear();
        lcd.setCursor(0,3);
        for(int i=0;i<data[1];i++) {
          lcd.print(data[i+2]);
        }
        break;
    }
    
  }
}
